AMPS C/C++ Client Class Reference AMPS C/C++ Client Version 5.3.5.6

Public Member Functions | List of all members
AMPS::RingBookmarkStore Class Reference

A BookmarkStoreImpl that stores only the MOST_RECENT bookmark to a file for recovery and keeps any bookmarks later than most recent in memory. More...

`#include <RingBookmarkStore.hpp>`

Inheritance diagram for AMPS::RingBookmarkStore:

## Public Member Functions
| RingBookmarkStore (const char *fileName_)
| Create a RingBookmarkStore using fileName_ for storage of most recent. More...
virtual size_t | log (Message &message_)
| Return the corresponding sequence number for this bookmark. More...
virtual void | discard (const Message &message_)
| Log a discard-bookmark entry to the persistent log based on a bookmark sequence number. More...
virtual void | discard (const Message::Field &subId_, size_t bookmarkSeqNo_)
| Log a discard-bookmark entry to the persistent log based on a bookmark sequence number. More...
virtual void | persisted (const Message::Field &subId_, const Message::Field &bookmark_)
| Mark the bookmark provided as replicated to all sync replication destinations for the given subscription. More...
virtual Message::Field | getMostRecent (const Message::Field &subId_)
| Returns the most recent bookmark from the log that ought to be used for (re-)subscriptions. More...
virtual void | purge ()
| Called to purge the contents of this store. More...
virtual void | purge (const Message::Field &subId_)
| Called to purge the contents of this store for particular subId. More...
Public Member Functions inherited from AMPS::MemoryBookmarkStore
| MemoryBookmarkStore ()
| Creates a MemoryBookmarkStore.
| MemoryBookmarkStore (const RecoveryPointAdapter &adapter_, RecoveryPointFactory factory_=NULL)
| Creates a MemoryBookmarkStore. More...
virtual bool | isDiscarded (Message &message_)
| Called for each arriving message to determine if the application has already seen this bookmark and should not be reprocessed. More...
virtual size_t | getOldestBookmarkSeq (const Message::Field &subId_)
| Called to find the oldest bookmark in the store. More...
virtual Message::Field | persisted (const Message::Field &subId_, size_t bookmark_)
| Mark the bookmark provided as replicated to all sync replication destinations for the given subscription. More...
void | setServerVersion (const VersionInfo &version_)
| Internally used to set the server version so the store knows how to deal with persisted acks and calls to getMostRecent(). More...
void | setServerVersion (size_t version_)
| Internally used to set the server version so the store knows how to deal with persisted acks and calls to getMostRecent(). More...
Public Member Functions inherited from AMPS::BookmarkStoreImpl
virtual void | setResizeHandler (BookmarkStoreResizeHandler handler_, void *userData_)
| Set a handler on the bookmark store that will get called whenever a resize of the store is required due to the number of stored bookmarks exceeding the currently allocated storage to hold them. More...
size_t | getMaxSubIdLength () const
| Gets the maximum allowed length for a sub id when recovering a bookmark store from persistent storage. More...
void | setMaxSubIdLength (size_t maxSubIdLength_)
| Sets the maximum allowed length for a sub id when recovering a bookmark store from persistent storage. More...

## Detailed Description

A BookmarkStoreImpl that stores only the MOST_RECENT bookmark to a file for recovery and keeps any bookmarks later than most recent in memory.

This class is best used when you want permanent storage for recovery on the client side, but expect to process all messages in order. It will not protect you from possibly missing or duplicate bookmarks that can occur if you are using a bookmark live subscription and you have to fail over to another AMPS instance which receives messages in a different order. The storage actually has 3 storage positions to allow for protection against crashes while updating storage.

## Constructor & Destructor Documentation

## ◆ RingBookmarkStore()

AMPS::RingBookmarkStore::RingBookmarkStore | ( | const char * | fileName_ | ) |
| inline

Create a RingBookmarkStore using fileName_ for storage of most recent.

If the file exists and has a valid bookmark, it will be recovered.

Parameters

  fileName_ | The name of the file to use for storage.

## Member Function Documentation

## ◆ discard() [1/2]

virtual void AMPS::RingBookmarkStore::discard | ( | const Message & | message_ | ) |
| inline virtual

Log a discard-bookmark entry to the persistent log based on a bookmark sequence number.

Parameters

  message_ | The Message to discard.

Reimplemented from AMPS::MemoryBookmarkStore.

## ◆ discard() [2/2]

virtual void AMPS::RingBookmarkStore::discard | ( | const Message::Field & | subId_,
|  | size_t | bookmarkSeqNo_
| ) |  |
| inline virtual

Log a discard-bookmark entry to the persistent log based on a bookmark sequence number.

Use the discard(const Message&) function instead when you have the full Message object available..

Parameters

  subId_ | The id of the subscription to which the bookmark applies.
  bookmarkSeqNo_ | The bookmark sequence number to discard.

Reimplemented from AMPS::MemoryBookmarkStore.

## ◆ getMostRecent()

virtual Message::Field AMPS::RingBookmarkStore::getMostRecent | ( | const Message::Field & | subId_ | ) |
| inline virtual

Returns the most recent bookmark from the log that ought to be used for (re-)subscriptions.

Parameters

  subId_ | The id of the subscription to check.

Reimplemented from AMPS::MemoryBookmarkStore.

## ◆ log()

virtual size_t AMPS::RingBookmarkStore::log | ( | Message & | message_ | ) |
| inline virtual

Return the corresponding sequence number for this bookmark.

Parameters

  message_ | The Message to check.

Reimplemented from AMPS::MemoryBookmarkStore.

## ◆ persisted()

virtual void AMPS::RingBookmarkStore::persisted | ( | const Message::Field & | subId_,
|  | const Message::Field & | bookmark_
| ) |  |
| inline virtual

Mark the bookmark provided as replicated to all sync replication destinations for the given subscription.

Parameters

  subId_ | The subscription Id to which the bookmark applies.
  bookmark_ | The most recent replicated bookmark.

Reimplemented from AMPS::MemoryBookmarkStore.

## ◆ purge() [1/2]

virtual void AMPS::RingBookmarkStore::purge | ( |  | ) |
| inline virtual

Called to purge the contents of this store.

Removes any tracking history associated with publishers and received messages, and may delete or truncate on-disk representations as well.

Reimplemented from AMPS::MemoryBookmarkStore.

## ◆ purge() [2/2]

virtual void AMPS::RingBookmarkStore::purge | ( | const Message::Field & | subId_ | ) |
| inline virtual

Called to purge the contents of this store for particular subId.

Removes any tracking history associated with publishers and received messages, and will remove the subId from the file as well.

Reimplemented from AMPS::MemoryBookmarkStore.

The documentation for this class was generated from the following file:

- include/amps/RingBookmarkStore.hpp